function board (cards) {
    // Data
    this.cards = cards;
    this.card_count = cards.length;
    this.row_length = Math.floor(Math.sqrt(cards.length));
    // Methods
    this.shuffle = function(){
        var new_cards = [];
        var count = this.card_count;
        var i = 0;
        while(this.cards.length > 0){
          var index = Math.round(Math.random()*count);
          if (this.cards[index]){
            new_cards[i] = this.cards.splice(index, 1)[0];
            i++;
          }
        }
        this.cards = new_cards;
    }
    this.draw = function(){
        this.shuffle();
        var html_string = '';
        for(var i=0; i<this.card_count; i++){
          html_string += '<div style="font-size:32px;width:50px;height:50px;border:2px solid black; margin:10px;float:left" id="c' + i + '" class="' + (this.cards[i].flipped ? 'card_front' : 'card_back') + '">';
          html_string += this.cards[i].draw();
          html_string += '</div>';
          if (!((i+1) % this.row_length) && !(i==0)){
            html_string += '<div style="clear:left;width:100%"></div>';
          }
        }
        $('#board').html(html_string);
        return html_string;
    }
    this.flip = function(i){
        this.cards[i].flip();
        $('#c' + i).html(this.cards[i].draw());
        $('#c' + i).attr('class', (this.cards[i].flipped ? 'card_front' : 'card_back'));
    }
	this.updateScore = function(newScore){
          $('#score_val').html(newScore);
    }
    this.updateTries = function(newTries){
          $('#tries_val').html(newTries);
    }
    this.remove = function(i){
        this.cards[i] = null;
        $('#c' + i).html('<p>-</p>');
        $('#c' + i).attr('class', ('no_card'));
    }
}